'------------------------------------------------------------------------------
' Tetris bacteria grows up in your glass. Kill it by clicking a figure
' consisting on 3 or more bricks of the same color. Enjoy!
'------------------------------------------------------------------------------
#Compiler PBWin 8
#Compile Exe "Anti-TetriS.exe"
%IDD_MAIN = 101
%IDC_GRAPHIC = 1001
%IDC_PLAY = 1002
%IDC_LEVEL = 1004
%IDC_QUIT = 1003
'-------------- A small piece of WIN32API.INC --------------------------
%Red = &H0000FF???
%White = &HFFFFFF???
%GWL_WNDPROC = -4
%WM_DESTROY = &H2
%WM_NCACTIVATE = &H086
%WM_COMMAND = &H111
%WM_LBUTTONDOWN = &H201
%WS_POPUP = &H80000000
%WS_CHILD = &H40000000
%WS_VISIBLE = &H10000000
%WS_CLIPSIBLINGS = &H04000000
%WS_CAPTION = &H00C00000
%WS_BORDER = &H00800000
%WS_DLGFRAME = &H00400000
%WS_SYSMENU = &H00080000
%WS_THICKFRAME = &H00040000
%WS_TABSTOP = &H00010000
%WS_MINIMIZEBOX = &H00020000
%WS_EX_LEFT = &H00000000
%WS_EX_LTRREADING = &H00000000
%WS_EX_RIGHTSCROLLBAR = &H00000000
%WS_EX_CONTROLPARENT = &H00010000
%WS_EX_STATICEDGE = &H00020000
%HWND_DESKTOP = 0
%BS_TEXT = &H0&
%BS_PUSHBUTTON = &H0&
%BS_CENTER = &H300&
%BS_VCENTER = &HC00&
%BS_FLAT = &H00008000&
%BN_CLICKED = 0
%SS_NOTIFY = &H00000100
%DS_3DLOOK = &H0004&
%DS_NOFAILCREATE = &H0010&
%DS_SETFONT = &H0040&
%DS_MODALFRAME = &H0080&
%DS_CENTER = &H0800&
'----------------------------------------------
Global hDlg As Dword
Global Level&
Global Score&, MaxScore&
Global CurColor&
Global Arr&()
Global ColorInd&()
Global Game&
Global Delay!
Global ImEditProc&
'----------------------------------------------
Declare Function Check_3(x As Long,y As Long) As Long
Declare CallBack Function ShowMAINProc()
Declare Function ShowMAIN(ByVal hParent As Dword) As Long
Declare Function CBImage (ByVal hCtl As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function CallWindowProc Lib "USER32.DLL" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Dword, ByVal hWnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Long) As Long
Declare Function GetFocus Lib "USER32.DLL" Alias "GetFocus" () As Dword
Declare Function SetFocus Lib "USER32.DLL" Alias "SetFocus" (ByVal hWnd As Dword) As Long
Declare Function SetWindowLong Lib "USER32.DLL" Alias "SetWindowLongA" (ByVal hWnd As Dword, ByVal nIndex As Long, ByVal lNewLong As Long) As Long
'----------------------------------------------
Function PBMain()
Level&=1: Delay!=2.5
MaxScore&=0: Score&=0
ReDim Arr&(17,11) ''' +1 for each dimension
Dim ColorInd&(4,2)
ColorInd&(0,1)=RGB(255,255,255): ColorInd&(0,2)=RGB(255,255,255) ' W
ColorInd&(1,1)=RGB(250,250,0) : ColorInd&(1,2)=RGB(190,190,0) ' Y
ColorInd&(2,1)=RGB(255,80,80) : ColorInd&(2,2)=RGB(120,0,0) ' R
ColorInd&(3,1)=RGB(0,220,0) : ColorInd&(3,2)=RGB(0,150,0) ' G
ColorInd&(4,1)=RGB(120,150,255): ColorInd&(4,2)=RGB(0,0,120) ' B
ShowMAIN %HWND_DESKTOP
End Function
'---------------------------------- GAME main -------------------------
Sub PlayGame
ReDim Arr&(17,11)
Game&=1: Score&=0
Randomize Timer
Graphic Clear %White
Control Disable hDlg, %IDC_PLAY
Do
For i&=1 To 16 '''' Shift UP
For j&=1 To 10
Arr&(i&,j&)=Arr&(i&+1,j&)
Next j&
Next i&
For j&=1 To 10 '''' Fill last row
Arr&(16,j&)=Rnd(1,4)
Next j&
Call RefreshPicture
For j&=1 To 10 '''' Check END
If Arr&(1,j&)<>0 Then Exit Do
Next j&
t!=Timer '''' Delay
Do: Dialog DoEvents: Loop While Timer-t!<Delay!
Loop ''' OK, you loose
Game&=0: Score&=Score&*Level&
If Score& > MaxScore& Then MaxScore&=Score&
Control Enable hDlg, %IDC_PLAY
Call PrintScore
End Sub
'-------------------------------- Graphic ------------------------------------
Sub RefreshPicture
Graphic Attach hDlg, %IDC_GRAPHIC
For i&=1 To 16
For j&=1 To 10
Call DrawBox(j&,i&,Arr&(i&,j&))
Next j&
Next i&
Graphic ReDraw
End Sub
'-----------------------------------------
Sub DrawBox(i&,j&,Clr&)
x&=(i&-1)*20: y&=(j&-1)*20
Graphic Box (x&,y&)-(x&+20, y&+20),,ColorInd&(Clr&,2),ColorInd&(Clr&,1)
Graphic Box (x&+2,y&+2)-(x&+17, y&+17),,ColorInd&(Clr&,2)
End Sub
'---------------------------------- Logic --------------------------------------
''' Check if 3 or more squares of the same color clicked '''
Function Check_3&(x&,y&)
CurColor&=Arr&(x&,y&): Sum&=1
If CurColor&=0 Then Function=0: Exit Function
i&=x&
Do ' Down
Incr i&
If Arr&(i&,y&)<>CurColor& Then Exit Do
If Arr&(i&,y&)=CurColor& Then Incr Sum&
If Arr&(i&,y&+1)=CurColor& Then Incr Sum&
If Arr&(i&,y&-1)=CurColor& Then Incr Sum&
Loop While i&<=16
i&=x&
Do
Decr i& 'Up
If Arr&(i&,y&)<>CurColor& Then Exit Do
If Arr&(i&,y&)=CurColor& Then Incr Sum&
If Arr&(i&,y&+1)=CurColor& Then Incr Sum&
If Arr&(i&,y&-1)=CurColor& Then Incr Sum&
Loop While i&>=1
i&=y&
Do
Incr i& ' Right
If Arr&(x&,i&)<>CurColor& Then Exit Do
If Arr&(x&,i&)=CurColor& Then Incr Sum&
If Arr&(x&+1,i&)=CurColor& Then Incr Sum&
If Arr&(x&-1,i&)=CurColor& Then Incr Sum&
Loop While i&<=10
i&=y&
Do
Decr i& ' Left
If Arr&(x&,i&)<>CurColor& Then Exit Do
If Arr&(x&,i&)=CurColor& Then Incr Sum&
If Arr&(x&+1,i&)=CurColor& Then Incr Sum&
If Arr&(x&-1,i&)=CurColor& Then Incr Sum&
Loop While i&>=1
If Sum&>2 Then Arr&(x&,y&)=9
Function=Sum&
End Function
'-----------------------------------------
''' A simple way to mark all squares of CurColor for deletion
Sub MarkChecked(x&,y&)
For i&=1 To 16
For j&=1 To 10
If Arr&(i&,j&)=9 Then GoSub Repl
Next j&
Next i&
For i&=16 To 1 Step -1
For j&=10 To 1 Step -1
If Arr&(i&,j&)=9 Then GoSub Repl
Next j&
Next i&
Exit Sub
Repl:
If Arr&(i&-1,j&)=CurColor& Then Arr&(i&-1,j&)=9: Incr Score&
If Arr&(i&+1,j&)=CurColor& Then Arr&(i&+1,j&)=9: Incr Score&
If Arr&(i&,j&-1)=CurColor& Then Arr&(i&,j&-1)=9: Incr Score&
If Arr&(i&,j&+1)=CurColor& Then Arr&(i&,j&+1)=9: Incr Score&
Return
End Sub
'-----------------------------------------
''' Delete all marked squares in Arr&() & drop down the rest
Sub DeleteChecked
For i&=1 To 10
For j&=1 To 16
If Arr&(j&,i&)=9 Then
For k&=j& To 1 Step-1: Arr&(k&,i&)=Arr&(k&-1,i&): Next k&
End If
Next j&
Next i&
End Sub
'---------------------------------------- Text -------------------------------
Sub PrintCover
Graphic Attach hDlg, %IDC_GRAPHIC
Graphic Box (20,100)-(180, 200),10,0,RGB(255,255,200)
Graphic Color %Red,RGB(255,255,200)
Graphic Font "Arial", 14, 1
Graphic Set Pos (50,110) : Graphic Print "Anti-TetriS"
Graphic Color 0,RGB(255,255,200)
Graphic Font "Arial", 10, 0
Graphic Set Pos (30,150) : Graphic Print "Click 3 or more bricks"
Graphic Set Pos (45,165) : Graphic Print "of the same color"
Graphic ReDraw
End Sub
'----------------------------------------------
Sub PrintScore
Graphic Attach hDlg, %IDC_GRAPHIC
Graphic Box (20,100)-(180, 200),10,0,RGB(255,255,200)
Graphic Color %Red,RGB(255,255,200)
Graphic Font "Arial", 14, 1
Graphic Set Pos (45,110) : Graphic Print "Game Over!"
Graphic Color 0,RGB(255,255,200)
Graphic Font "Arial", 10, 0
Graphic Set Pos (45,150) : Graphic Print "Score : "
Graphic Set Pos (45,165) : Graphic Print "Max Score : "
Graphic Font "Arial", 10, 1
Graphic Set Pos (120,150): Graphic Print Str$(Score&)
Graphic Set Pos (120,165): Graphic Print Str$(MaxScore&)
Graphic ReDraw
End Sub
'---------------------------------- Callbacks ----------------------------------
CallBack Function ShowMAINProc()
Select Case As Long CbMsg
Case %WM_NCACTIVATE
Static hWndSaveFocus As Dword
If IsFalse CbWParam Then
hWndSaveFocus = GetFocus()
ElseIf hWndSaveFocus Then
SetFocus(hWndSaveFocus)
hWndSaveFocus = 0
End If
Case %WM_DESTROY
SetWindowLong ImEditProc, %GWL_WNDPROC, CbHndl
Case %WM_COMMAND
Select Case As Long CbCtl
Case %IDC_GRAPHIC
Case %IDC_PLAY
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
PlayGame
End If
Case %IDC_QUIT
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
Dialog End CbHndl
End If
Case %IDC_LEVEL
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
Incr Level&: If Level&>5 Then Level&=1
Delay!=2.5/Level&
Control Set Text CbHndl,%IDC_LEVEL, "Level "+Str$(Level&)
End If
End Select
End Select
End Function
'-----------------------------------------------
' PICTURE CLICK
Function CBImage (ByVal hCtl As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long
Select Case wMsg
Case %WM_LBUTTONDOWN ''''
If Game&=0 Then Exit Function
My&=LoWrd(lParam) : Mx&=HiWrd(lParam)
y&=My&\20+1: x&=Mx&\20+1 ''' Array indexes
If Arr&(x&,y&)=0 Then Exit Function
If Check_3&(x&,y&)>2 Then ''' 3 or more clicked:
MarkChecked(x&,y&) ''' mark them,
For i&=1 To 16: For j&=1 To 10 ''' paint white,
If Arr&(i&,j&)=9 Then Call DrawBox(j&,i&,0)
Next j& : Next i&
t!=Timer ''' and make a small delay
Do: Dialog DoEvents: Loop While Timer-t!<0.1
DeleteChecked ''' Delete: in Arr&(),
RefreshPicture ''' on screen
End If
End Select
Function = CallWindowProc(ByVal ImEditProc,hCtl,wMsg,wParam,lParam)
End Function
'----------------------------------- Dialog ------------------------------------------
Function ShowMAIN(ByVal hParent As Dword) As Long
Local lRslt As Long
Local hWndIm As Dword
Dialog New Pixels, hParent, " Anti-TetriS", 200, 100, 220, 380, %WS_POPUP Or _
%WS_BORDER Or %WS_DLGFRAME Or %WS_THICKFRAME Or %WS_CAPTION Or _
%WS_SYSMENU Or %WS_MINIMIZEBOX Or %WS_CLIPSIBLINGS Or %WS_VISIBLE Or _
%DS_MODALFRAME Or %DS_CENTER Or %DS_3DLOOK Or %DS_NOFAILCREATE Or _
%DS_SETFONT, %WS_EX_CONTROLPARENT Or %WS_EX_LEFT Or _
%WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
Dialog Set Color hDlg, -1, RGB(95, 175, 175)
Control Add Button, hDlg, %IDC_PLAY, "Play Game", 10, 340, 70, 24, _
%WS_CHILD Or %WS_VISIBLE Or %WS_TABSTOP Or %BS_TEXT Or _
%BS_PUSHBUTTON Or %BS_FLAT Or %BS_CENTER Or %BS_VCENTER, _
%WS_EX_STATICEDGE Or %WS_EX_LEFT Or %WS_EX_LTRREADING
Control Add Button, hDlg, %IDC_LEVEL, "Level 1", 80, 340, 60, 24, _
%WS_CHILD Or %WS_VISIBLE Or %WS_TABSTOP Or %BS_TEXT Or _
%BS_PUSHBUTTON Or %BS_FLAT Or %BS_CENTER Or %BS_VCENTER, _
%WS_EX_STATICEDGE Or %WS_EX_LEFT Or %WS_EX_LTRREADING
Control Add Button, hDlg, %IDC_QUIT, "Back to Job", 140, 340, 70, 24, _
%WS_CHILD Or %WS_VISIBLE Or %WS_TABSTOP Or %BS_TEXT Or _
%BS_PUSHBUTTON Or %BS_FLAT Or %BS_CENTER Or %BS_VCENTER, _
%WS_EX_STATICEDGE Or %WS_EX_LEFT Or %WS_EX_LTRREADING
Control Add Graphic, hDlg, %IDC_GRAPHIC, "", 10, 10, 200, 320, %WS_CHILD Or _
%WS_VISIBLE Or %WS_BORDER Or %SS_NOTIFY
Graphic Attach hDlg, %IDC_GRAPHIC, ReDraw
Graphic Clear %White
Control Handle hDlg, %IDC_GRAPHIC To hWndIm
ImEditProc = SetWindowLong(hWndIm,%GWL_WNDPROC,ByVal CodePtr(CBImage))
Call PrintCover
Dialog Show Modal hDlg, Call ShowMAINProc To lRslt
Function = lRslt
End Function
'--------------------------------- EOJ ------------------------------------------
